//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    22:11:38 08/04/2012 
// Design Name: 
// Module Name:    DIV_768KHz 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////


`timescale 1ns / 1ps
// Enforce explicit net declaration for this module:
`default_nettype none

module DIV_48KHz
#(
  parameter period = 2560
)
(
  output reg clkdivout,
  input wire reset,
  input wire clk 
);

function [31:0] log2;
   input [31:0] value;
   integer i;
   reg [31:0] j;
   begin
      j = value - 1;
      log2 = 0;
      for (i = 0; i < 31; i = i + 1)
        if (j[i]) log2 = i+1;
   end
endfunction

localparam halfperiod = period / 2;
reg [log2(period)-1:0] countvalue;

always @(posedge clk)
  begin
    if (reset)
      begin
        countvalue <= 0;
        clkdivout <= 0;
      end
    else
      begin
        if(countvalue == period - 1)
          begin
            countvalue <= 0;
            clkdivout <= 0;
          end
        else
          countvalue <= countvalue + 1;
        if (countvalue == halfperiod - 1) // For 50% duty cycle if period is even
          clkdivout <= 1;
      end
  end
endmodule
// Don't enforce explicit net declaration for other modules:
`default_nettype wire

