
module pkt_writer(
	input wire clk,
	input wire [7:0]rbyte,
	input wire [10:0]rbyte_addr,
	input wire rbyte_valid,
	input wire crc32_ok,
	output wire [13:0]wr_addr,
	output wire wr,
	output reg [2:0]head = 0 //ptr to next packet being received
);

//if packet received OK then increase head, mean receive next packet
always @(posedge clk)
	if(crc32_ok)
	begin
		head <= head+1;
	end

//write into 2 sram banks interleaved
assign wr_addr = { head, rbyte_addr[10:0] };
assign wr = rbyte_valid;

endmodule

