`timescale 1ns / 1ps

  module sender(
	input wire tx_clk,			//25Mhz clock from eth phy
	input wire [7:0]data,
	input wire [10:0]fifo_usedw,
	
	output wire fifo_req,
	output reg [3:0]txd,
	output wire txd_en
);

reg c;
always @(posedge tx_clk)
	c<=~c;

reg [3:0]sr;
always @(posedge tx_clk)
	sr <= { sr[2:0], (fifo_usedw>1) & c };

always @(posedge tx_clk)
	if(c)
		txd<=data[3:0];
	else
		txd<=data[7:4];

assign fifo_req = sr[0];	
assign txd_en = sr[3] | sr[2];

endmodule
